﻿// Duration of locking the generate report button, ms
var GEN_BTN_LOCK_DURATION = 3000;
// Name of the item stores output format
var FORMAT_ITEM_NAME = "ElasticReport.Format";

// Select begin or end date using a calendar popup
function selectDate(inputElem, buttonElem) {
    scada.dialogs.showCalendar(buttonElem, inputElem.val(), function (dialogResult, extraParams) {
        if (dialogResult) {
            inputElem.val(extraParams.dateStr);
        }
    });
}

// Start report generation
function generateReport(reportID, startDate, endDate) {
    var queryString = "?reportID=" + reportID + "&startDate=" + startDate + "&endDate=" + endDate;

    if ($("#rbExcelFormat").is(":checked")) {
        localStorage.setItem(FORMAT_ITEM_NAME, "Excel"); // save format
        lockGenerateButton();
        window.location = "ElasticRepExcelOut.aspx" + queryString;
    } else if ($("#rbPdfFormat").is(":checked")) {
        localStorage.setItem(FORMAT_ITEM_NAME, "PDF"); // save format
        lockGenerateButton();
        window.location = "ElasticRepPdfOut.aspx" + queryString;
    } else {
        localStorage.setItem(FORMAT_ITEM_NAME, "HTML"); // save format
        window.open("ElasticRepHtmlOut.aspx" + queryString);
    }
}

// Lock the generate report button after click
function lockGenerateButton() {
    $("#btnGenReport").prop("disabled", true);
    $("#lblGenStarted").removeClass("hidden");

    setTimeout(function () {
        $("#btnGenReport").prop("disabled", false);
        $("#lblGenStarted").addClass("hidden");
    }, GEN_BTN_LOCK_DURATION)
}

$(document).ready(function () {
    // open a calendar popup on a calendar button click
    $("button.calendar")
        .on("click", function () {
            selectDate($(this).parent().siblings("input"), $(this));
        });

    if (scada.utils.iOS()) {
        // disable Excel and PDF formats for iOS
        $("#rbHtmlFormat").prop("checked", true);
        $("#rbExcelFormat").prop("disabled", true);
        $("#divExcelFormat").addClass("disabled");
        $("#rbPdfFormat").prop("disabled", true);
        $("#divPdfFormat").addClass("disabled");
    } else {
        var format = localStorage.getItem(FORMAT_ITEM_NAME);
        // switch to stored format
        if (format == "PDF") {
            $("#rbPdfFormat").prop("checked", true);
        }
        else if (format == "HTML") {
            $("#rbHtmlFormat").prop("checked", true);
        }
    }
});